



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ROS知识（24）——ros::spin()和spinOnce的含义及其区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ROS知识（24）——ros::spin()和spinOnce的含义及其区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 00:36:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1.ros::spin()和spinOnce含义</strong></p>
<p>如果在节点中如果订阅了话题,那么就必须要调用ros::sping()或者ros::spinOnce()函数去处理话题绑定的回调函数,否则该节点将不会调用节点所订阅的所有回调函数来处理接收到的数据.换句话说如果一个节点里面没有订阅话题只有发布话题,那么是可以不需要调用这两个函数的.但是为了方便以后节点添加了订阅消息话题,建议还是加上这两个函数之一.下面是关于这两个函数的讨论:</p>
<p><a href="https://answers.ros.org/question/257361/what-is-the-actual-meaning-of-rosspin/" rel="external nofollow noreferrer">What is the actual meaning of ros::spin()</a></p>
<p><a href="http://wiki.ros.org/action/fullsearch/ROS/Tutorials/WritingPublisherSubscriber%28c%2B%2B%29?action=fullsearch&amp;context=180&amp;value=linkto%3A%22ROS%2FTutorials%2FWritingPublisherSubscriber%28c%2B%2B%29%22" rel="external nofollow noreferrer">WritingPublisherSubscriber(c++)</a></p>
<p><strong>2.多线程调用ros::spin()和spinOnce</strong></p>
<p>我们注意到 ros::spin()只会单独开辟一个单一线程去处理这些回调函数队列,当订阅不同频率的话题时,那么所有订阅话题的接收频率为所有话题处理最慢的一个,为了能够让话题接收不同的频率,我们可以使用<strong>ros::MultiThreadedSpinner</strong>&nbsp;或者<strong>ros::AsyncSpinner</strong>&nbsp;来解决问题.例如:</p>
<p>MultiThreadedSpinner类似于ros::spin()，在构造过程中可以指定它所用线程数，但如果不指定线程数或者线程数设置为0，它将在每个cpu内核开辟一个线程。</p>
<div>
<pre class="prettyprint linenums">ros::MultiThreadedSpinner spinner(); // Use 4 threads<br />
spinner.spin(); // spin() will not return until the node has been shutdown</pre>
</div>
<p>AsyncSpinner比MultiThreadedSpinner更优，它有start() 和stop() 函数，并且在销毁的时候会自动停止。</p>
<div>
<pre class="prettyprint linenums">[code]ros::AsyncSpinner spinner(); // Use 4 threads<br />
spinner.start();<br />
ros::waitForShutdown();</pre>
</div>
<p>详细请参考:</p>
<p><a href="http://wiki.ros.org/action/fullsearch/roscpp/Overview/Callbacks%20and%20Spinning?action=fullsearch&amp;context=180&amp;value=linkto%3A%22roscpp%2FOverview%2FCallbacks+and+Spinning%22" rel="external nofollow noreferrer">Callbacks and Spinning</a>(官方介绍)</p>
<p><a href="http://www.lai18.com/content/6936523.html" rel="external nofollow noreferrer">【ROS学习】（六）ROS多线程订阅消息</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8enyk81.html">ASP&period;NET用QQ&comma;网易发送邮件以及添加附件</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn2rlkq.html">用Python生成组织机构代码，附源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd47evq.html">【C】 03 - 数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmo7d19.html">iOS iphone屏幕分析（岂止而大）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd5g3r8.html">5&period;迪米特法则（Law Of Demeter）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xd1408.html">C&num; 解压RAR压缩文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1x4kj9.html">文件I&sol;O（不带缓冲）之原子操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k161o79.html">ln命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm6p3e9.html">写下你的第一个Django应用，第三部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/9503zpz8.html">Python学习笔记&mdash;&mdash;进阶篇【第九周】&mdash;&mdash;&mdash;线程、进程、协程篇（队列Queue和生产者消费者模型）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj5e728.html">python 、mmap 实现内存数据共享</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z3wl39.html">stack 的入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdve179.html">elasticsearch 源码本地环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyvx4z9.html">剑指Offer面试题 二维数组中的查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rj1vm9.html">产线nginx路径跳转问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/963owy39.html">IdentityServer4结合AspNetCore&period;Identity实现登录认证踩坑填坑记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp2w149.html">SAP查找用户的登录记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk2oz38.html">一段遍历4X4表格，取出每个单元格内容组合成文本的JS代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvem52y9.html">Java中替换字符串中特殊字符&plus; 20150921</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zknmwn8.html">Linux命令行下的vim文本编辑器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/960krdn9.html">ubuntu系统下Python虚拟环境的安装和使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25nzywq.html">transfer pdf to png</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j20p0q.html">xpath定位</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rn3d08.html">Win7  x64 svn 服务器搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j2e30q.html">HTTP请求报文和响应报文</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvpkvy8.html">放弃WebView，使用Crosswalk做富文本编辑器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e46exj9.html">bzoj4184</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdjnld9.html">Asp&period;Net Core 2&period;0 项目实战（5）Memcached踩坑，基于EnyimMemcachedCore整理MemcachedHelper帮助类。</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ej2lq.html">【Java】 剑指offer&lpar;45&rpar; 把数组排成最小的数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j16zow9.html">ubuntu16&period;04下vim的安装与配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
